"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.configureCastore = void 0;

var _toolkit = require("@reduxjs/toolkit");

var _adapter = require("./adapter");

var _getCastoreReducers = require("./getCastoreReducers");

var _getEventStoreSliceName = require("./utils/getEventStoreSliceName");

var configureCastore = function configureCastore(_ref) {
  var eventStores = _ref.eventStores,
      _ref$prefix = _ref.prefix,
      prefix = _ref$prefix === void 0 ? _getEventStoreSliceName.DEFAULT_PREFIX : _ref$prefix;
  var castoreReducers = (0, _getCastoreReducers.getCastoreReducers)({
    eventStores: eventStores,
    prefix: prefix
  });
  var store = (0, _toolkit.configureStore)({
    reducer: castoreReducers
  });
  eventStores.forEach(function (eventStore) {
    eventStore.eventStorageAdapter = new _adapter.ReduxEventStorageAdapter({
      store: store,
      eventStoreId: eventStore.eventStoreId,
      prefix: prefix
    });
  });
  return store;
};

exports.configureCastore = configureCastore;
//# sourceMappingURL=configureCastore.js.map