"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useExistingAggregate = void 0;

var _core = require("@castore/core");

var _useAggregate2 = require("./useAggregate");

var useExistingAggregate = function useExistingAggregate(eventStore, aggregateId) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _useAggregate = (0, _useAggregate2.useAggregate)(eventStore, aggregateId, options),
      aggregate = _useAggregate.aggregate,
      events = _useAggregate.events,
      lastEvent = _useAggregate.lastEvent;

  if (aggregate === undefined || lastEvent === undefined) {
    throw new _core.AggregateNotFoundError({
      eventStoreId: eventStore.eventStoreId,
      aggregateId: aggregateId
    });
  }

  return {
    aggregate: aggregate,
    events: events,
    lastEvent: lastEvent
  };
};

exports.useExistingAggregate = useExistingAggregate;
//# sourceMappingURL=useExistingAggregate.js.map