import { configureStore } from '@reduxjs/toolkit';
import { ReduxEventStorageAdapter } from "./adapter";
import { getCastoreReducers } from "./getCastoreReducers";
import { DEFAULT_PREFIX } from "./utils/getEventStoreSliceName";
export var configureCastore = function configureCastore(_ref) {
  var eventStores = _ref.eventStores,
      _ref$prefix = _ref.prefix,
      prefix = _ref$prefix === void 0 ? DEFAULT_PREFIX : _ref$prefix;
  var castoreReducers = getCastoreReducers({
    eventStores: eventStores,
    prefix: prefix
  });
  var store = configureStore({
    reducer: castoreReducers
  });
  eventStores.forEach(function (eventStore) {
    eventStore.eventStorageAdapter = new ReduxEventStorageAdapter({
      store: store,
      eventStoreId: eventStore.eventStoreId,
      prefix: prefix
    });
  });
  return store;
};
//# sourceMappingURL=configureCastore.js.map