import { AggregateNotFoundError } from '@castore/core';
import { useAggregate } from "./useAggregate";
export var useExistingAggregate = function useExistingAggregate(eventStore, aggregateId) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _useAggregate = useAggregate(eventStore, aggregateId, options),
      aggregate = _useAggregate.aggregate,
      events = _useAggregate.events,
      lastEvent = _useAggregate.lastEvent;

  if (aggregate === undefined || lastEvent === undefined) {
    throw new AggregateNotFoundError({
      eventStoreId: eventStore.eventStoreId,
      aggregateId: aggregateId
    });
  }

  return {
    aggregate: aggregate,
    events: events,
    lastEvent: lastEvent
  };
};
//# sourceMappingURL=useExistingAggregate.js.map