import type { EnhancedStore } from '@reduxjs/toolkit';
import { EventStorageAdapter, EventDetail, PushEventOptions } from '@castore/core';
import type { EventStoreReduxState, EventStoresReduxState } from './types';
export declare class ReduxEventStorageAdapter implements EventStorageAdapter {
    getEvents: EventStorageAdapter['getEvents'];
    pushEventSync: (eventDetail: EventDetail, options: PushEventOptions) => Awaited<ReturnType<EventStorageAdapter['pushEvent']>>;
    pushEvent: EventStorageAdapter['pushEvent'];
    pushEventGroup: EventStorageAdapter['pushEventGroup'];
    groupEvent: EventStorageAdapter['groupEvent'];
    listAggregateIds: EventStorageAdapter['listAggregateIds'];
    store: EnhancedStore<EventStoresReduxState>;
    eventStoreId: string;
    eventStoreSliceName: string;
    getEventStoreState: () => EventStoreReduxState;
    constructor({ store, eventStoreId, prefix, }: {
        store: EnhancedStore<EventStoresReduxState>;
        eventStoreId: string;
        prefix?: string;
    });
}
//# sourceMappingURL=adapter.d.ts.map